Zoho Projects API Documentation
Text copied
File not found

Skill History

This module covers history operations for skills within a Zoho Projects portal. Use this API to retrieve the audit history of changes made to a skill, including user associations, level updates, and field edits.

Get Skill History

Retrieve the audit history for a specific skill, including user associations, level updates, and field edits.

GET

/api/v3/portal/[PORTAL_ID]/skills/[SKILL_ID]/history

OAuth Scope:

ZohoProjects.skillset.READ

Path Parameters

Param Name
Data Type
Description

Query Parameters

Param Name
Data Type
Description

Request Example

Request Example
  • cURL
  • Deluge
  • Node.js
  • Ruby
  • PHP
  • Python
  • C
  • C#
  • C++
  • Clojure
  • Go
  • HTTP
  • Java
  • JS Fetch
  • JSON
  • Kotlin
  • Objective-C
  • OCaml
  • PowerShell
  • R
  • Swift

curl -X GET \
'https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history?token=eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9' \
-H 'Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'

url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history";
params = Map();
params.put("token", "eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9");
response = invokeUrl
[
    url: url
    type: GET
    parameters: params
    connection: "projects"
];
info response;
const https = require('https');
const url = new URL('https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history');
url.searchParams.append('token', 'eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9');

const options = {
  hostname: url.hostname,
  path: url.pathname + url.search,
  method: 'GET',
  headers: {
    'Authorization': 'Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'
  }
};

const req = https.request(options, (res) => {
  let data = '';
  res.on('data', (chunk) => { data += chunk; });
  res.on('end', () => { console.log(JSON.parse(data)); });
});

req.on('error', (err) => { console.error(err); });
req.end();
require 'net/http'
require 'uri'
require 'json'

url = URI("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history")
params = {
  "token" => "eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9"
}
url.query = URI.encode_www_form(params)

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Get.new(url)
request["Authorization"] = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"

response = http.request(request)
puts response.read_body
<?php
$params = [
    'token' => 'eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9',
];
$url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history" . "?" . http_build_query($params);

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => $url,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_CUSTOMREQUEST => "GET",
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
  ],
]);

$response = curl_exec($curl);
curl_close($curl);

echo $response;
import requests

url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history"

params = {
    "token": "eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9"
}

headers = {
    "Authorization": "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa",
}

response = requests.get(url, headers=headers, params=params)

print(response.json())
#include <stdio.h>
#include <string.h>
#include <curl/curl.h>

int main(void) {
    CURL *curl = curl_easy_init();
    if (curl) {
        char *enc_token = curl_easy_escape(curl, "eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9", 0);
        char url[2048];
        snprintf(url, sizeof(url), "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history?token=%s", enc_token);

        struct curl_slist *headers = NULL;
        headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");

        curl_easy_setopt(curl, CURLOPT_URL, url);
        curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
        curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "GET");

        CURLcode res = curl_easy_perform(curl);
        if (res != CURLE_OK)
            fprintf(stderr, "curl failed: %s\n", curl_easy_strerror(res));

        curl_free(enc_token);
        curl_slist_free_all(headers);
        curl_easy_cleanup(curl);
    }
    return 0;
}
using System.Net.Http;
using System.Text;
using System.Web;

var client = new HttpClient();
client.DefaultRequestHeaders.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");

var query = HttpUtility.ParseQueryString(string.Empty);
query["token"] = "eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9";
var uriBuilder = new UriBuilder("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history") { Query = query.ToString() };
var request = new HttpRequestMessage(HttpMethod.Get, uriBuilder.Uri);

var response = await client.SendAsync(request);
var body = await response.Content.ReadAsStringAsync();
Console.WriteLine(body);
#include <iostream>
#include <string>
#include <curl/curl.h>

static size_t WriteCallback(void* contents, size_t size, size_t nmemb, std::string* output) {
    output->append((char*)contents, size * nmemb);
    return size * nmemb;
}

int main() {
    CURL* curl = curl_easy_init();
    if (curl) {
        std::string response;
        char* enc_token = curl_easy_escape(curl, "eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9", 0);
        std::string url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history";
        url += "?token=" + std::string(enc_token);

        struct curl_slist* headers = NULL;
        headers = curl_slist_append(headers, "Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");

        curl_easy_setopt(curl, CURLOPT_URL, url.c_str());
        curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);
        curl_easy_setopt(curl, CURLOPT_CUSTOMREQUEST, "GET");
        curl_easy_setopt(curl, CURLOPT_WRITEFUNCTION, WriteCallback);
        curl_easy_setopt(curl, CURLOPT_WRITEDATA, &response);

        CURLcode res = curl_easy_perform(curl);
        if (res == CURLE_OK)
            std::cout << response << std::endl;
        else
            std::cerr << curl_easy_strerror(res) << std::endl;

        curl_free(enc_token);
        curl_slist_free_all(headers);
        curl_easy_cleanup(curl);
    }
    return 0;
}
(require '[clj-http.client :as client])

(let [enc-token (java.net.URLEncoder/encode "eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9" "UTF-8")
      url (str "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history" "?token=" enc-token)]
(def response
  (client/get url
    {:headers {"Authorization" "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"}
     :as :json}))

(println (:body response))
package main

import (
    "fmt"
    "io"
    "net/http"
    "net/url"
)

func main() {
    req, _ := http.NewRequest("GET", "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history", nil)
    q := req.URL.Query()
    q.Add("token", "eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9")
    req.URL.RawQuery = q.Encode()
    req.Header.Add("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")

    resp, _ := http.DefaultClient.Do(req)
    defer resp.Body.Close()
    body, _ := io.ReadAll(resp.Body)
    fmt.Println(string(body))
}
GET https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history?token=eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9 HTTP/1.1
Host: https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history?token=eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9
Authorization: Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa
HttpClientBuilder httpClientBuilder = HttpClientBuilder.create();

SSLContext sslContext = SSLContext.getDefault();
SSLConnectionSocketFactory sslConnectionSocketFactory = new SSLConnectionSocketFactory(sslContext, NoopHostnameVerifier.INSTANCE);
CloseableHttpClient httpclient = httpClientBuilder.setSSLSocketFactory(sslConnectionSocketFactory).build();

URIBuilder uriBuilder = new URIBuilder("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history");
uriBuilder.addParameter("token", "eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9");
HttpUriRequest requestObj = new HttpGet(uriBuilder.build());
requestObj.addHeader("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa");

HttpResponse response = httpclient.execute(requestObj);

HttpEntity responseEntity = response.getEntity();
Object responseObject = EntityUtils.toString(responseEntity);
String responseString = responseObject.toString();
const url = 'https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history';

const params = new URLSearchParams({
  'token': 'eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9'
});

const options = {
  method: 'GET',
  headers: {
    'Authorization': 'Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa'
  }
};

fetch(url + '?' + params.toString(), options)
  .then(response => response.json())
  .then(data => console.log(data))
  .catch(error => console.error(error));
token = "eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9"
import java.net.HttpURLConnection
import java.net.URL
import okhttp3.HttpUrl.Companion.toHttpUrl

fun main() {
    val urlBuilder = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history".toHttpUrl().newBuilder()
    urlBuilder.addQueryParameter("token", "eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9")
    val url = URL(urlBuilder.build().toString())
    val conn = url.openConnection() as HttpURLConnection
    conn.requestMethod = "GET"
    conn.setRequestProperty("Authorization", "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa")

    val response = conn.inputStream.bufferedReader().readText()
    println(response)
}
NSString *encodedToken = [@"eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9" stringByAddingPercentEncodingWithAllowedCharacters:[NSCharacterSet URLQueryAllowedCharacterSet]];
NSString *urlString = [NSString stringWithFormat:@"https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history?token=%@", encodedToken];
NSURL *url = [NSURL URLWithString:urlString];
NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
[request setHTTPMethod:@"GET"];
[request setValue:@"Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa" forHTTPHeaderField:@"Authorization"];

NSURLSession *session = [NSURLSession sharedSession];
NSURLSessionDataTask *task = [session dataTaskWithRequest:request
    completionHandler:^(NSData *data, NSURLResponse *response, NSError *error) {
        NSString *result = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
        NSLog(@"%@", result);
}];
[task resume];
open Lwt
open Cohttp_lwt_unix

let () =
  let enc_token = Uri.pct_encode "eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9" in
  let uri = Uri.of_string ("https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history" ^ "?token=" ^ enc_token) in
  let headers = Cohttp.Header.init ()
    |> fun h -> Cohttp.Header.add h "Authorization" "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
  in
  Lwt_main.run (
    Client.get ~headers uri >>= fun (_, body) ->
    Cohttp_lwt.Body.to_string body >|= fun s ->
    print_endline s)
$headers = @{
    "Authorization" = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"
}

$params = @{
    token = "eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9"
}
$queryString = ($params.GetEnumerator() | ForEach-Object { "$($_.Key)=$([System.Uri]::EscapeDataString($_.Value))" }) -join "&"
$url = "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history" + "?" + $queryString

$response = Invoke-RestMethod -Uri $url -Method GET -Headers $headers

$response | ConvertTo-Json
library(httr)

url <- "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history"

params <- list(
  token = "eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9"
)

response <- GET(
  url,
  add_headers(Authorization = "Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa"),
  query = params
)

content(response, "text")
import Foundation

var components = URLComponents(string: "https://projects.zoho.com/api/v3/portal/[PORTAL_ID]/skills/8000000123001/history")!
components.queryItems = [
    URLQueryItem(name: "token", value: "eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9")
]
let url = components.url!
var request = URLRequest(url: url)
request.httpMethod = "GET"
request.setValue("Bearer 1000.03xxxxxxxxxxxxxxxxxa5317.dxxxxxxxxxxxxxxxxxfa", forHTTPHeaderField: "Authorization")

let semaphore = DispatchSemaphore(value: 0)
let task = URLSession.shared.dataTask(with: request) { data, response, error in
    if let data = data, let result = String(data: data, encoding: .utf8) {
        print(result)
    }
    semaphore.signal()
}
task.resume()
semaphore.wait()

Sample Input

token : "eyJ0eXBlIjoic2tpbGxfaGlzdG9yeSIsInRva2VuIjoiODAwMDAwMDEyMzAwMSJ9"

Sample Response

200[ { "id" : "8000000200001", "action_time" : "2025-04-20T09:15:00.000Z", "operation" : "associated", "entity" : "React", "action_by" : { "id" : "8000000002055", "full_name" : "Elle Jason", "email" : "elle.jason@zylker.com", "zpuid" : "8000000002055" }, "source" : "user", "changes" : [ { "type" : "skill_user_association", "added" : [ { "name" : "Monica Hemsworth", "level" : "intermediate" } ], "removed" : [ ], "level_changed" : [ ] } ] }, { "id" : "8000000200002", "action_time" : "2025-02-15T14:30:00.000Z", "operation" : "level_changed", "entity" : "React", "action_by" : { "id" : "8000000002411", "full_name" : "John Smith", "email" : "john.smith@zylker.com", "zpuid" : "8000000002411" }, "source" : "user_skill", "target_user" : { "id" : "8000000002055", "full_name" : "Elle Jason", "email" : "elle.jason@zylker.com", "zpuid" : "8000000002055" }, "changes" : [ { "display_name" : "Skill Level", "old_value" : "beginner", "new_value" : "advanced" } ] }, { "id" : "8000000200003", "action_time" : "2024-11-10T09:00:00.000Z", "operation" : "create", "entity" : "React", "action_by" : { "id" : "8000000002143", "full_name" : "Monica Hemsworth", "email" : "monica.hemsworth@zylker.com", "zpuid" : "8000000002143" }, "source" : "user", "changes" : [ ] } ]

Possible Errors

AI Tools
ChatGPT Open in ChatGPT ↗ Open in ChatGPT to ask questions about this page
Claude Open in Claude ↗ Open in Claude to ask questions about this page
Copy as Markdown Copy this page as markdown to use with AI assistants
View as Markdown ↗ Open this page as markdown in a new tab
Copy OpenAPI Spec Copy the OpenAPI YAML to the clipboard
View as YAML ↗ Open the OpenAPI spec in a new tab
Download YAML Save the OpenAPI spec as a .yaml file